/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

/* load an empty text document */
oSheetComponent = xComponentLoader~loadComponentFromURL("private:factory/scalc", "_blank", 0, .OOo~noProps)

xDocument   =oSheetComponent~XSpreadSheetDocument
xSheets     =xDocument~getSheets
xIndexSheets=xSheets~XIndexAccess
xSheet      =xIndexSheets~getByIndex(0)~XSpreadSheet  -- get the spreadsheet interface for the sheet

-- (1) setCell dummy data
call OOo.setCell xSheet, 0, 0, 5.2
call OOo.setCell xSheet, 0, 2, 2.3

-- (2) Calculate and print average
result = avgNonEmpty(0, 0, 0, 2, xSheet)
call OOo.setCell xSheet, 0, 3, result

-- (3) setCell some labels
call OOo.setCell xSheet, 1, 1, "<- Remains empty"
call OOo.setCell xSheet, 1, 3, "<- The average"


::requires OOO.CLS   -- ooRexx support for OpenOffice.org


-- A function to calculate the average not considering empty fields
::routine avgNonEmpty
use arg fromx, fromy, tox, toy, container
	sum = 0
	fieldCount = 0

	do i=fromx to tox
		do j=fromy to toy
			currentValue = container~getCellByPosition(i, j) ~getValue
			if currentValue <> "0.0" then
			do
				sum = sum + currentValue
				fieldCount = fieldCount + 1
			end
		end
	end

	if fieldCount > 0 then return (sum/fieldCount)

	return 0

